import { Button, Checkbox } from "antd";
import React from "react";

import './Index.scss';

function NoticeManager(props){

  return(
    <div className="notice01">
      <div className="sshHead">
        <span className="text-shadow07">通知管理</span>
      </div>
      <div>
        <span className="notice-manager-tip">您可以通过通知管理来选择接受通知的方式</span>
        <div className="manager-cont-top">
          我创建或负责的
        </div>
        <div className="manager-cont">
          <div className="manager-cont-title">易修状态变更</div>
          <Checkbox defaultChecked='true' disabled>站内信</Checkbox>
          <Checkbox >邮件</Checkbox>
        </div>
        <div className="manager-cont">
          <div className="manager-cont-title">易修截止日期到达最后一天</div>
          <Checkbox defaultChecked='true' disabled>站内信</Checkbox>
          <Checkbox >邮件</Checkbox>
        </div>
        <div className="manager-cont">
          <div className="manager-cont-title">合并请求状态变更</div>
          <Checkbox defaultChecked='true' disabled>站内信</Checkbox>
          <Checkbox >邮件</Checkbox>
        </div>
        <div className="manager-cont">
          <div className="manager-cont-title">易修有新的评论</div>
          <Checkbox defaultChecked='true'>站内信</Checkbox>
          <Checkbox >邮件</Checkbox>
        </div>
        <div className="manager-cont">
          <div className="manager-cont-title">合并请求有新的评论</div>
          <Checkbox defaultChecked='true'>站内信</Checkbox>
          <Checkbox >邮件</Checkbox>
        </div>

        <div className="manager-cont-top">
          我管理的仓库
        </div>
        <div className="manager-cont">
          <div className="manager-cont-title">被关注</div>
          <Checkbox defaultChecked='true'>站内信</Checkbox>
          <Checkbox >邮件</Checkbox>
        </div>
        <div className="manager-cont">
          <div className="manager-cont-title">被点赞</div>
          <Checkbox defaultChecked='true'>站内信</Checkbox>
          <Checkbox >邮件</Checkbox>
        </div>
        <div className="manager-cont">
          <div className="manager-cont-title">被复刻</div>
          <Checkbox defaultChecked='true'>站内信</Checkbox>
          <Checkbox >邮件</Checkbox>
        </div>
        <div className="manager-cont">
          <div className="manager-cont-title">有新的里程碑</div>
          <Checkbox defaultChecked='true'>站内信</Checkbox>
          <Checkbox >邮件</Checkbox>
        </div>

        <div className="manager-cont-top">
          我关注的仓库
        </div>
        <div className="manager-cont">
          <div className="manager-cont-title">被删除</div>
          <Checkbox defaultChecked='true'>站内信</Checkbox>
          <Checkbox >邮件</Checkbox>
        </div>
        <div className="manager-cont">
          <div className="manager-cont-title">被转移</div>
          <Checkbox defaultChecked='true'>站内信</Checkbox>
          <Checkbox >邮件</Checkbox>
        </div>
        <div className="manager-cont">
          <div className="manager-cont-title">有新的易修</div>
          <Checkbox defaultChecked='true'>站内信</Checkbox>
          <Checkbox >邮件</Checkbox>
        </div>
        <div className="manager-cont">
          <div className="manager-cont-title">有新的合并请求</div>
          <Checkbox defaultChecked='true'>站内信</Checkbox>
          <Checkbox >邮件</Checkbox>
        </div>
        <div className="manager-cont">
          <div className="manager-cont-title">有新的版本发布</div>
          <Checkbox defaultChecked='true'>站内信</Checkbox>
          <Checkbox >邮件</Checkbox>
        </div>
      </div>
    </div>
  )
}
export default NoticeManager;