import React  from 'react';
import styled from 'styled-components';
import { Modal ,Button } from 'antd';

const Div = styled.div`{
  height:130px;
  line-height:130px;
  text-align:center;
  color:#333;
}`
export default (({visible , closeFunc , sureFunc})=>{
  return(
    <Modal
      title="提示"
      visible={visible}
      closable={true}
      footer={
        <div>
          <Button onClick={()=>closeFunc(false)}>取消</Button>
          <Button type={"primary"} onClick={()=>sureFunc()} style={{marginLeft:"20px"}}>确定</Button>
        </div>
      }
      onCancel={()=>closeFunc(false)}
    >
      <Div>工作流配置完成，您的DevOps之旅即刻开启！</Div>
    </Modal>
  )
})
