import React from 'react';
import { Link } from 'react-router-dom';
import'./sub.scss'

function SubMenu({tab,owner,projectsId}) {
  return(
    <ul className="subMenu">
      <Link to={`/${owner}/${projectsId}/tags`} className={tab==="tags"?"active":""}>标签</Link>
      <Link to={`/${owner}/${projectsId}/releases`} className={tab==="releases"?"active":""}>发行版</Link>
    </ul>
  )
}
export default SubMenu;