import React from 'react';
import { Link } from 'react-router-dom';

export default (({ name , count , bottom , children , url })=>{
  return(
    <div className="box">
      <div className="head">
        <span className="font-16">{name}</span>
        <Link to={url}>{count}<i className="iconfont icon-youjiantou font-12 ml3"></i></Link>
      </div>
      <div className="content">
        {children}
      </div>
      {
        bottom ? 
        <div className="foot">
          {bottom}
        </div>
        :""
      }
    </div>
  )
})
