import React, { Component } from 'react';
import './TPMShixunDiscuss.css'

import Challenges from './shixunchild/Challenges/Challenges'
import Challengesjupyter from './shixunchild/Challenges/Challengesjupyter'
import TPMRightSection from './component/TPMRightSection'


class TPMChallenge extends Component {
  constructor(props) {
    super(props)

  }

  render() {
    const { is_jupyter } = this.props;
    return (
      <React.Fragment>
        <div className="educontent clearfix mt30 mb80">
          <div className="with65 fl " >
            {
              is_jupyter === true ?
                <Challengesjupyter
                  {...this.props}
                />
                :
                <Challenges
                  {...this.props}
                />
            }
          </div>
          <div className="with35 fr pl20">
            <TPMRightSection
              {...this.props}
            />
          </div>
        </div>
      </React.Fragment>

    );
  }
}

export default TPMChallenge;
